
/*------------------------------------------------------------*/
/*------------------------------------------------------------*/
function zGetCellName(ix,iy){	
	return gi_table.getCellName(ix,iy);
}

function zGetCellPop(ix,iy,iv){
	return gi_table.zGetCellPop(ix,iy);
}

function zGetCellClick(ix,iy,iv){
	return gi_table.zOnCellClick(ix,iy);	
}


/*------------------------------------------------------------*/
/*------------------------------------------------------------*/
function zDrawNightZone(iv_month,iv_day,iv_hour){
	var lv_midRA=zGetMidRA(iv_month,iv_day,iv_hour)
	
	//flip midRA:
	lv_midRA=24-lv_midRA;
	
	if(lv_midRA>=6 && lv_midRA<=18){
		//only one bar needed:
			zDrawBar(	0,0,
						lv_midRA-6,lv_midRA+6,
						24,24
					);
	}else{
		//two bar needed:
		if(lv_midRA<6){
			//dawn
			zDrawBar(	0,lv_midRA+6,
						12,12,
						24-(6-lv_midRA),24
					);
		}else{
			//dusk
			zDrawBar(	0,(lv_midRA+6)-24,
						12,12,
						lv_midRA-6,24						
					);
		}
		
	}
}

function zDrawBar(	iv_ll,iv_lr,
					iv_ml,iv_mr,
					iv_rl,iv_rr	){
/* left/right in parameter means the smaller/bigger in number,
   not actural position in graphic                       */
	
	var lv_left;
	var lv_width;
	
	//left bar:
	lv_left=C_BAR_LEFT+iv_ll*C_BAR_SIZE;
	lv_width=(iv_lr-iv_ll)*C_BAR_SIZE;

	gi_BarL.animate({
						x: lv_left,
						width: lv_width
					});
					
					
	//middle bar:
	lv_left=C_BAR_LEFT+iv_ml*C_BAR_SIZE;
	lv_width=(iv_mr-iv_ml)*C_BAR_SIZE;

	gi_BarM.animate({
						x: lv_left,
						width: lv_width
					});
					
					
	//right bar:
	lv_left=C_BAR_LEFT+iv_rl*C_BAR_SIZE;
	lv_width=(iv_rr-iv_rl)*C_BAR_SIZE;

	gi_BarR.animate({
						x: lv_left,
						width: lv_width
					});
   
}

function zGetMidRA(iv_month,iv_day,iv_hour){
	/* Definition:
		0hr in top middle sky when local time is: 3.21 12:00   */
	
	var lv_temp=0;
	
	//hour shift:
	lv_temp=(iv_hour-12);
	if(lv_temp<0) lv_temp=lv_temp+24;
	
	//month shift:
	lv_temp=lv_temp+((iv_month-3)*2);
	if(lv_temp<0) lv_temp=lv_temp+24;
	if(lv_temp>=24) lv_temp=lv_temp-24;
	
	//day shift:
	if(iv_day<7) lv_temp=lv_temp-1;
	if(lv_temp<0) lv_temp=lv_temp+24;
	
	return lv_temp;
	
}




/*------------------------------------------------------------*/
function zAdd(iv_unit){
	if(iv_unit=='M')	gi_time.setMonth(gi_time.getMonth() + 1);
	if(iv_unit=='D')	gi_time.setDate(gi_time.getDate() + 1);
	if(iv_unit=='H')	gi_time.setHours(gi_time.getHours() + 1);
	
	zUpdateTimeDisplay();
}

function zMinus(iv_unit){
	if(iv_unit=='M')	gi_time.setMonth(gi_time.getMonth() - 1);
	if(iv_unit=='D')	gi_time.setDate(gi_time.getDate() - 1);
	if(iv_unit=='H')	gi_time.setHours(gi_time.getHours() - 1);
	
	zUpdateTimeDisplay();
}

function zSetActive(iv){
	if(iv==gv_active) gv_active='';
		else gv_active=iv;
	zUpdateTimeDisplay();
}

function zResetNow(){
	gi_time=new Date()
	
	var lv_h;
	lv_h=gi_time.getHours();
	if(lv_h>7 && lv_h<19) gi_time.setHours(19);
	
	
	gv_active='';
		
	zUpdateTimeDisplay();
}

function zUpdateTimeDisplay(){
	var lv_m,lv_d,lv_h;
	var lv;	
	
	lv_m=gi_time.getMonth()+1;
	lv_d=gi_time.getDate();
	lv_h=gi_time.getHours();
	
	zDrawNightZone(lv_m,lv_d,lv_h);
	
	if(gv_active=='M') lv_m='<font color='+C_COLOR_ACT+'>'+lv_m+'</font>';
	if(gv_active=='D') lv_d='<font color='+C_COLOR_ACT+'>'+lv_d+'</font>';
	if(gv_active=='H') lv_h='<font color='+C_COLOR_ACT+'>'+lv_h+'</font>';
	
	lv= '<b><font color='+C_COLOR_TEXT+'>'+lv_m+'.'+lv_d+' '+lv_h+':00'+'</font></b>';
	
	var li=document.getElementById('containerUIT');
	li.innerHTML =lv;	
	
}

function zHelp(){
	var lv='';
	lv=zAppend(lv,'《今晚天上有什么》测试版');
	lv=zAppend(lv,'===测试版说明===');
	lv=zAppend(lv,'启动后自己手动先点一下上面Reset');
	lv=zAppend(lv,'数据暂时都是空的');
	lv=zAppend(lv,'哪位有安卓手机/平板的麻烦帮我试一下如果把网页拷到手机/平板里是否能用，谢谢');
	lv=zAppend(lv,'');
	lv=zAppend(lv,'===说明===');
	lv=zAppend(lv,'此为天区速查工具，帮助初学者了解头顶的天空有些什么星座，分别有哪些目标。');
	lv=zAppend(lv,'此工具只提供粗略讯息供参考，要定位查找目标还需借助星图。');
	lv=zAppend(lv,'===用法===');
	lv=zAppend(lv,'主表格是一张北半球中维度地区，观察者面向南方的星图，左东右西');
	lv=zAppend(lv,'横坐标为赤经，不多解释');
	lv=zAppend(lv,'纵坐标为赤维，我将其分为5组，自上而下分别为：');
	lv=zAppend(lv,'N——代表“北”，即北天极附近，这一组的星座基本都在观察者北方');
	lv=zAppend(lv,'T——代表“顶端”，这一组的星座不是东升西落就几乎在头顶上方');
	lv=zAppend(lv,'S——代表“南”，即南方天空');
	lv=zAppend(lv,'H——代表“地平线”，即南方地平线附近，这些星座在高维度地区可能不可见');
	lv=zAppend(lv,'I——代表“不可见”，主要是南半球星座，在我国大部分地区不可见');
	lv=zAppend(lv,'');
	lv=zAppend(lv,'表格上方有一黑条，代表此时天空的位置。让使用者知道“当前日期时间”头顶的天空“在哪里”');
	lv=zAppend(lv,'几个按钮用来调整“当前日期时间”，功能显而易见，就不多说了');
	lv=zAppend(lv,'鼠标悬停在一个单元格上显示摘要信息：');
	lv=zAppend(lv,'Dp:3/1 代表有3个易见深空天体，1个较暗难见深空天体');
	lv=zAppend(lv,'St:0/1 代表有0个易见恒星目标，1个较暗难见恒星目标');
	lv=zAppend(lv,'点击单元格后下方列出详情');
	lv=zAppend(lv,'');
	lv=zAppend(lv,'');
	lv=zAppend(lv,'');
	lv=zAppend(lv,'牧夫ID：B-2688');
	lv=zAppend(lv,'2016.2.26');
	lv=zAppend(lv,'<a href=http://www.astronomy.com.cn/bbs/forum.php?mod=viewthread&tid=374027&page=1#pid4010187 target=_blank><font color=white>希望收到您的宝贵易见</font></a>');
	lv=zAppend(lv,'');
	lv=zAppend(lv,'.');
	
	zPrint(lv);
}
/*------------------------------------------------------------*/
/*------------------------------------------------------------*/

function zAppend(iv1,iv2){
	if (iv1=='') return iv2;
		else return iv1+'<br>'+iv2;
}

function zPrint(iv){	
		document.getElementById(C_DIV_CONT).innerHTML=iv;
}

